#include <stdio.h>
#define SPD_MCU 0xf;
#define SPD_RANK 0x2;
#define SPD_18JSF1G72AZ_1G9E1_E1 {\
  0x92, 0x11, 0x0b, 0x02, 0x04, 0x21, 0x00, 0x09, 0x0b, 0x11, 0x01, 0x08, 0x09, 0x00, 0xfe, 0x02, 0x69, 0x78, 0x69, 0x28, \
  0x69, 0x11, 0x10, 0x79, 0x20, 0x08, 0x3c, 0x3c, 0x00, 0xc8, 0x83, 0x05, 0x80, 0x00, 0xca, 0x00, 0x00, 0x00, 0x00, 0x00, \
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
  0x0f, 0x11, 0x64, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x2c, 0x0f, \
  0x12, 0x42, 0xde, 0x99, 0xa4, 0xb2, 0x3f, 0x7b, 0x31, 0x38, 0x4a, 0x53, 0x46, 0x31, 0x47, 0x37, 0x32, 0x41, 0x5a, 0x2d, \
  0x31, 0x47, 0x39, 0x45, 0x31, 0x20, 0x45, 0x31, 0x80, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, \
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, }

/* VDC DIMM for bring-up */
#define VDC_8GB_18JSF1G72AZ_1G9E1  {\
	0x92, 0x13, 0x0b, 0x02, 0x04, 0x21, 0x00, 0x09, 0x0b, 0x11, 0x01, 0x08, 0x09, 0x00, 0xfe, 0x02, 0x69, 0x78, 0x69, 0x28, \
	0x69, 0x11, 0x10, 0x79, 0x20, 0x08, 0x3c, 0x3c, 0x00, 0xc8, 0x83, 0x05, 0x80, 0x00, 0xca, 0x00, 0x00, 0x00, 0x00, 0x00, \
	0x00, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
	0x0f, 0x11, 0x64, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x2c, 0x0f, \
	0x13, 0x47, 0x32, 0x21, 0x4a, 0x51, 0x56, 0xbf, 0x31, 0x38, 0x4a, 0x53, 0x46, 0x31, 0x47, 0x37, 0x32, 0x41, 0x5a, 0x2d, \
	0x31, 0x47, 0x39, 0x45, 0x31, 0x20, 0x45, 0x31, 0x80, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, \
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, }

	#define SPD_XUNO  {\
		0x92, 0x13, 0x0b, 0x02, 0x04, 0x21, 0x00, 0x09, 0x0b, 0x11, 0x01, 0x08, 0x09, 0x00, 0xfe, 0x02, 0x69, 0x78, 0x69, 0x28, \
		0x69, 0x11, 0x10, 0x79, 0x20, 0x08, 0x3c, 0x3c, 0x00, 0xc8, 0x83, 0x05, 0x80, 0x00, 0xca, 0x00, 0x00, 0x00, 0x00, 0x00, \
		0x00, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
		0x0f, 0x11, 0x64, /*MIR*/0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x2c, 0x0f, \
		0x13, 0x47, 0x32, 0x21, 0x4a, 0x51, /*CRC*/0x31, 0x23, 0x31, 0x38, 0x4a, 0x53, 0x46, 0x31, 0x47, 0x37, 0x32, 0x41, 0x5a, 0x2d, \
		0x31, 0x47, 0x39, 0x45, 0x31, 0x20, 0x45, 0x31, 0x80, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, \
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, \
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, }
char fix_spd[256] = /*VDC_2GB_9965432_029_A00LF*/ SPD_XUNO ;

char ddr_info[256];

//char global_offset[16];
//char ddr_header[4];
//char DDRMCU[1] = {0x1};
//char DDRRANK[1] = {0x2};
//char DDRCHIP_PART[1] = {0x2};
int main (void)
{

  FILE *fp;
  int i;

  fp = fopen ("spdeeprom.bin", "w");
  if (fp == NULL)
    {
      printf ("I couldn't open results.dat for writing.\n");
    }
  int mcu_off = CONFIG_EEPROM_DDR_MCU_OFFSET - 256;
  int rank_off = CONFIG_EEPROM_DDR_RANK_OFFSET - 256;
  int mcu_val = SPD_MCU;
  int rank_val = SPD_RANK;
//  if(mcu_off%2){
//      mcu_val = mcu_val<<4;
//      mcu_off = mcu_off -1;
//  }
//  if(rank_off%2){
//      rank_val = rank_val<<4;
//      rank_off = rank_off -1;
//  }
  ddr_info[mcu_off] =  /*ddr_info[mcu_off]|*/mcu_val;
  ddr_info[rank_off] = /*ddr_info[mcu_off]|*/rank_val;
  printf("spd MCU 0x%08x %d 0x%x\n",CONFIG_EEPROM_DDR_MCU_OFFSET,mcu_off,ddr_info[mcu_off] );
  printf("spd Rank 0x%08x %d 0x%x\n",CONFIG_EEPROM_DDR_RANK_OFFSET,rank_off,ddr_info[rank_off] );

  for (i = 0; i < 256; ++i)
    fprintf (fp, "%c", fix_spd[i]);
  for (i = 0; i < 256; ++i)
    fprintf (fp, "%c", ddr_info[i]);

  return 0;
}
